<?php
	$data = json_decode(file_get_contents('php://input'), true);
	if(isset($data)){
		$_POST = $data;
	}
	
	if(isset($_POST)){
		if(file_exists('../../../wp-blog-header.php')){
			require_once '../../../wp-blog-header.php';
		}else{
			require_once '../../../__wp__/wp-blog-header.php';
		}
		require_once './payvalida-authorize-woocommerce-gateway.php';
		$payvalida = new WC_Payvalida(false);
		if (empty($_POST['po_id'])||!preg_match("/^[a-zA-Z0-9' ]*$/",$_POST['po_id'])){
			echo '{
				"status":"error"
				"type":"Invalid po_id"
			}';
			exit;
		}
		$po_id = sanitize_text_field($_POST['po_id']);		
		if (empty($_POST['status'])||!preg_match("/^[a-zA-Z-' ]*$/",$_POST['status'])){
			echo '{
				"status":"error"
				"type":"Invalid status"
			}';
			exit;
		}
		$status =sanitize_text_field($_POST['status']);
		if (empty($_POST['amount'])||!preg_match("/^[0-9.,' ]*$/",$_POST['amount'])){
			echo '{
				"status":"error"
				"type":"Invalid amount"
			}';
			exit;
		}
		$amount = sanitize_text_field($_POST['amount']);
		if (empty($_POST['pv_checksum'])){
			echo '{
				"status":"error"
				"type":"Invalid pv_checksum"
			}';
			exit;
		}
		$pv_checksum = sanitize_text_field($_POST['pv_checksum']);
		$FIXED_HASH_NOTIFICACION=$payvalida->get_api_key();
		$pv_checksum_c = hash('sha256', $po_id . $status . $FIXED_HASH_NOTIFICACION);
		if(!($pv_checksum_c == $pv_checksum)){
			echo '{
				"status":"error"
				"type":"pv_checksum invalid"
			}';
			exit;
		}
		$po_id = sanitize_text_field($_POST['po_id']);
		$status = sanitize_text_field($_POST['status']);
		$order = new WC_Order($po_id);
		if(!isset($order)){
			echo '{
				"status":"error"
				"type":"order not exist"
			}';
			exit;
		}
		switch ($status) {
			case "approved":
				$order->update_status("processing", "Pago aceptado", false);
				echo '{
					"status":"ok"
					"type":"update_status processing"
				}';
				break;
			case "cancelled":
				$order->update_status("cancelled", "Pago cancelado", false);
				echo '{
					"status":"ok"
					"type":"update_status cancelled"
				}';
				break;
		}
		exit;
	}
?>